/* Generated by Edge Impulse
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*/
// Generated on: 12.09.2021 08:57:42

#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include "edge-impulse-sdk/tensorflow/lite/c/builtin_op_data.h"
#include "edge-impulse-sdk/tensorflow/lite/c/common.h"
#include "edge-impulse-sdk/tensorflow/lite/micro/micro_mutable_op_resolver.h"
#include "edge-impulse-sdk/porting/ei_classifier_porting.h"

#if EI_CLASSIFIER_PRINT_STATE
#if defined(__cplusplus) && EI_C_LINKAGE == 1
extern "C" {
    extern void ei_printf(const char *format, ...);
}
#else
extern void ei_printf(const char *format, ...);
#endif
#endif

#if defined __GNUC__
#define ALIGN(X) __attribute__((aligned(X)))
#elif defined _MSC_VER
#define ALIGN(X) __declspec(align(X))
#elif defined __TASKING__
#define ALIGN(X) __align(X)
#endif

using namespace tflite;
using namespace tflite::ops;
using namespace tflite::ops::micro;

namespace {

constexpr int kTensorArenaSize = 336;

#if defined(EI_CLASSIFIER_ALLOCATION_STATIC)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX)
#pragma Bss(".tensor_arena")
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#pragma Bss()
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX_GNU)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16) __attribute__((section(".tensor_arena")));
#else
#define EI_CLASSIFIER_ALLOCATION_HEAP 1
uint8_t* tensor_arena = NULL;
#endif

static uint8_t* tensor_boundary;
static uint8_t* current_location;

template <int SZ, class T> struct TfArray {
  int sz; T elem[SZ];
};
enum used_operators_e {
  OP_FULLY_CONNECTED, OP_SOFTMAX,  OP_LAST
};
struct TensorInfo_t { // subset of TfLiteTensor used for initialization from constant memory
  TfLiteAllocationType allocation_type;
  void* data;
  TfLiteIntArray* dims;
  size_t bytes;
};
struct NodeInfo_t { // subset of TfLiteNode used for initialization from constant memory
  struct TfLiteIntArray* inputs;
  struct TfLiteIntArray* outputs;
  void* builtin_data;
  used_operators_e used_op_index;
};

TfLiteContext ctx{};
TfLiteTensor tflTensors[14];
TfLiteEvalTensor tflEvalTensors[14];
TfLiteRegistration registrations[OP_LAST];
TfLiteNode tflNodes[5];

const TfArray<2, int> tensor_dimension0 = { 2, { 1,2 } };
const ALIGN(8) float tensor_data1[20] = { 0, -0.16576039791107178, 0, 0, -0.0069325990043580532, 0, -0.048628892749547958, 0.15208390355110168, -0.1624860018491745, -0.13722991943359375, 0, -0.17194394767284393, 0.0079292263835668564, 0.13277418911457062, 0, 0.13268099725246429, 0.19083887338638306, 0, 0, 0.16194829344749451, };
const TfArray<1, int> tensor_dimension1 = { 1, { 20 } };
const ALIGN(8) float tensor_data2[10] = { 0.13025771081447601, 0, -0.11380521953105927, -0.17189596593379974, 0, 0.13714504241943359, -0.041960801929235458, -0.15975932776927948, -0.076753683388233185, 0, };
const TfArray<1, int> tensor_dimension2 = { 1, { 10 } };
const ALIGN(8) float tensor_data3[5] = { -0.17497718334197998, -0.027986297383904457, -0.077553391456604004, 0, -0.12838010489940643, };
const TfArray<1, int> tensor_dimension3 = { 1, { 5 } };
const ALIGN(8) float tensor_data4[3] = { -2.7986135482788086, -1.6700789928436279, 4.055633544921875, };
const TfArray<1, int> tensor_dimension4 = { 1, { 3 } };
const ALIGN(8) float tensor_data5[20*2] = { 
  -0.38262632489204407, -0.35815846920013428, 
  0.11620219796895981, 0.043472442775964737, 
  -0.0038314461708068848, -0.50780773162841797, 
  -0.50461775064468384, -0.13925302028656006, 
  0.0019296230748295784, 0.33036273717880249, 
  0.25979131460189819, -0.29230624437332153, 
  -0.43493092060089111, 0.41649025678634644, 
  -0.22437262535095215, 0.56958532333374023, 
  0.20152834057807922, 0.13670840859413147, 
  0.01282828114926815, 0.041502222418785095, 
  -0.41374149918556213, -0.42791000008583069, 
  0.42927959561347961, 0.18675591051578522, 
  0.20241795480251312, 0.39671850204467773, 
  -0.020744495093822479, 0.16800446808338165, 
  -0.30546820163726807, -0.51373440027236938, 
  -0.47423294186592102, 0.50452470779418945, 
  -0.46521106362342834, 0.52725154161453247, 
  -0.22858336567878723, 0.028075993061065674, 
  -0.34804478287696838, -0.10923066735267639, 
  -0.23451164364814758, 0.29701685905456543, 
};
const TfArray<2, int> tensor_dimension5 = { 2, { 20,2 } };
const ALIGN(8) float tensor_data6[10*20] = { 
  -0.27318322658538818, -0.008591952733695507, 0.12290698289871216, 0.074745476245880127, 0.41941618919372559, -0.26030060648918152, -0.081083923578262329, 0.17582941055297852, -0.35403168201446533, -0.28829699754714966, -0.13624599575996399, -0.24328786134719849, 0.41363787651062012, 0.39200496673583984, -0.12032896280288696, 0.53642576932907104, 0.02747940830886364, 0.060225605964660645, -0.12740728259086609, 0.23775507509708405, 
  -0.28059786558151245, 0.062615931034088135, -0.2165655642747879, 0.1667969822883606, 0.10580015182495117, 0.03812822699546814, 0.3000338077545166, -0.18902638554573059, -0.15555453300476074, -0.3112604022026062, 0.068653404712677002, -0.33239167928695679, -0.1014312207698822, -0.13121494650840759, -0.33105406165122986, -0.3712192177772522, -0.17653581500053406, 0.2822265625, 0.20760005712509155, -0.36843103170394897, 
  -0.33629399538040161, 0.32175174355506897, 0.10381579399108887, -0.21731001138687134, 0.25932350754737854, -0.0071354806423187256, 0.16601903736591339, -0.23264519870281219, 0.36387595534324646, 0.28530251979827881, -0.25146210193634033, -0.15997752547264099, 0.1488567590713501, -0.40630257129669189, 0.1347496509552002, -1.4857407808303833, -0.55521273612976074, 0.42122942209243774, -0.38097769021987915, -0.28371503949165344, 
  -0.28346842527389526, -0.12708359956741333, -0.26081410050392151, -0.35208278894424438, -0.15907829999923706, 0.19693940877914429, 0.24270392954349518, 0.18757008016109467, 0.32850539684295654, -0.46591755747795105, 0.33046531677246094, 0.13405820727348328, -0.05595722422003746, -0.35030031204223633, -0.10104566812515259, -0.17450633645057678, -0.3763432502746582, 0.12087708711624146, 0.1122550368309021, -0.50874865055084229, 
  0.064222872257232666, 0.02722698450088501, -0.23178304731845856, -0.32580304145812988, -0.42718395590782166, 0.3694617748260498, -0.15084272623062134, -0.025713235139846802, -0.25466746091842651, 0.42222774028778076, 0.021470248699188232, -0.42019453644752502, -0.37079283595085144, 0.15604168176651001, -0.067081749439239502, 0.081021785736083984, 0.079031646251678467, -0.38482159376144409, 0.41780859231948853, 0.10166460275650024, 
  0.25995397567749023, 0.35537236928939819, -0.34178513288497925, 0.037643402814865112, -0.24108855426311493, -0.08388867974281311, 0.026884555816650391, 0.0026924456469714642, 0.40984782576560974, -0.25455257296562195, -0.44195234775543213, 0.3928007185459137, -0.31247842311859131, 0.22842925786972046, -0.21736885607242584, 1.571459174156189, 0.17421247065067291, -0.034634679555892944, -0.36985573172569275, 0.51554208993911743, 
  0.34139341115951538, -0.17078176140785217, 0.049364060163497925, 0.33769255876541138, 0.2256845086812973, -0.11952245235443115, 0.026262041181325912, 0.15804392099380493, 0.14332014322280884, 0.33271148800849915, -0.20815537869930267, 0.21386867761611938, -0.47222474217414856, -0.077358238399028778, -0.028545290231704712, -0.070648737251758575, 0.12596233189105988, -0.090127915143966675, 0.15623247623443604, -0.23691388964653015, 
  -0.23455004394054413, 0.36540135741233826, -0.23938150703907013, -0.40966156125068665, -0.1651148647069931, -0.069684982299804688, -0.15538634359836578, -0.47479042410850525, 0.35336899757385254, 0.12669369578361511, 0.27529001235961914, 0.39625090360641479, -0.11179936677217484, -0.070292964577674866, -0.096387922763824463, -1.2995628118515015, -0.83886146545410156, 0.069599449634552002, -0.17828625440597534, -0.056727740913629532, 
  -0.29330170154571533, 0.26962664723396301, 0.030253827571868896, 0.19904410839080811, 0.3534792959690094, -0.013660132884979248, 0.20866481959819794, -0.4922139048576355, -0.10421422123908997, -0.38845190405845642, 0.17745882272720337, 0.31304571032524109, 0.35747310519218445, 0.38895228505134583, -0.070620715618133545, -0.15329670906066895, -0.63454991579055786, 0.38830500841140747, -0.0054910182952880859, -0.12236805260181427, 
  -0.11671972274780273, 0.13775122165679932, 0.090843796730041504, 0.33198225498199463, -0.31399047374725342, 0.25487184524536133, 0.30278134346008301, -0.23711861670017242, 0.32591980695724487, -0.14984172582626343, -0.084425866603851318, 0.12879723310470581, -0.36235195398330688, -0.14282727241516113, -0.34809771180152893, 0.093096077442169189, 0.4212457537651062, 0.40072882175445557, -0.14276808500289917, 0.4010164737701416, 
};
const TfArray<2, int> tensor_dimension6 = { 2, { 10,20 } };
const ALIGN(8) float tensor_data7[5*10] = { 
  -0.37896379828453064, -0.058617472648620605, -0.42572140693664551, -0.11940848827362061, -0.14946219325065613, 0.2531108558177948, -0.1153532937169075, -0.67190009355545044, 0.0622294582426548, -0.24780312180519104, 
  0.33660539984703064, -0.55896604061126709, 0.32095801830291748, -0.024131078273057938, 0.18961507081985474, 0.087796010076999664, -0.55415976047515869, 0.13547122478485107, -0.55274587869644165, 0.16020941734313965, 
  -0.69247263669967651, 0.51904040575027466, 0.92707794904708862, 0.14267420768737793, 0.24051153659820557, -0.10515660792589188, 0.074443615972995758, 0.9628300666809082, 0.65972000360488892, -0.3551405668258667, 
  -0.56155037879943848, 0.037237703800201416, 0.29565787315368652, 0.23308712244033813, -0.054677665233612061, 0.064260482788085938, 0.3574976921081543, -0.48304730653762817, -0.38637185096740723, -0.38320964574813843, 
  -0.14327909052371979, 0.50776225328445435, 1.1664174795150757, 0.060373947024345398, -0.45679506659507751, -0.37997108697891235, 0.19105455279350281, 1.0052742958068848, -0.035307627171278, -0.50401288270950317, 
};
const TfArray<2, int> tensor_dimension7 = { 2, { 5,10 } };
const ALIGN(8) float tensor_data8[3*5] = { 
  0.23941527307033539, 0.31632569432258606, 0.28563991189002991, 0.056059598922729492, 1.4894284009933472, 
  -0.34451624751091003, 0.55754369497299194, 0.92937719821929932, -0.76779806613922119, -2.4970214366912842, 
  -0.38568565249443054, -0.6977839469909668, -1.1797546148300171, 0.31838315725326538, -0.72702127695083618, 
};
const TfArray<2, int> tensor_dimension8 = { 2, { 3,5 } };
const TfArray<2, int> tensor_dimension9 = { 2, { 1,20 } };
const TfArray<2, int> tensor_dimension10 = { 2, { 1,10 } };
const TfArray<2, int> tensor_dimension11 = { 2, { 1,5 } };
const TfArray<2, int> tensor_dimension12 = { 2, { 1,3 } };
const TfArray<2, int> tensor_dimension13 = { 2, { 1,3 } };
const TfLiteFullyConnectedParams opdata0 = { kTfLiteActRelu, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs0 = { 3, { 0,5,1 } };
const TfArray<1, int> outputs0 = { 1, { 9 } };
const TfLiteFullyConnectedParams opdata1 = { kTfLiteActRelu, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs1 = { 3, { 9,6,2 } };
const TfArray<1, int> outputs1 = { 1, { 10 } };
const TfLiteFullyConnectedParams opdata2 = { kTfLiteActRelu, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs2 = { 3, { 10,7,3 } };
const TfArray<1, int> outputs2 = { 1, { 11 } };
const TfLiteFullyConnectedParams opdata3 = { kTfLiteActNone, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs3 = { 3, { 11,8,4 } };
const TfArray<1, int> outputs3 = { 1, { 12 } };
const TfLiteSoftmaxParams opdata4 = { 1 };
const TfArray<1, int> inputs4 = { 1, { 12 } };
const TfArray<1, int> outputs4 = { 1, { 13 } };
const TensorInfo_t tensorData[] = {
  { kTfLiteArenaRw, tensor_arena + 80, (TfLiteIntArray*)&tensor_dimension0, 8, },
  { kTfLiteMmapRo, (void*)tensor_data1, (TfLiteIntArray*)&tensor_dimension1, 80, },
  { kTfLiteMmapRo, (void*)tensor_data2, (TfLiteIntArray*)&tensor_dimension2, 40, },
  { kTfLiteMmapRo, (void*)tensor_data3, (TfLiteIntArray*)&tensor_dimension3, 20, },
  { kTfLiteMmapRo, (void*)tensor_data4, (TfLiteIntArray*)&tensor_dimension4, 12, },
  { kTfLiteMmapRo, (void*)tensor_data5, (TfLiteIntArray*)&tensor_dimension5, 160, },
  { kTfLiteMmapRo, (void*)tensor_data6, (TfLiteIntArray*)&tensor_dimension6, 800, },
  { kTfLiteMmapRo, (void*)tensor_data7, (TfLiteIntArray*)&tensor_dimension7, 200, },
  { kTfLiteMmapRo, (void*)tensor_data8, (TfLiteIntArray*)&tensor_dimension8, 60, },
  { kTfLiteArenaRw, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension9, 80, },
  { kTfLiteArenaRw, tensor_arena + 80, (TfLiteIntArray*)&tensor_dimension10, 40, },
  { kTfLiteArenaRw, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension11, 20, },
  { kTfLiteArenaRw, tensor_arena + 32, (TfLiteIntArray*)&tensor_dimension12, 12, },
  { kTfLiteArenaRw, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension13, 12, },
};const NodeInfo_t nodeData[] = {
  { (TfLiteIntArray*)&inputs0, (TfLiteIntArray*)&outputs0, const_cast<void*>(static_cast<const void*>(&opdata0)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs1, (TfLiteIntArray*)&outputs1, const_cast<void*>(static_cast<const void*>(&opdata1)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs2, (TfLiteIntArray*)&outputs2, const_cast<void*>(static_cast<const void*>(&opdata2)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs3, (TfLiteIntArray*)&outputs3, const_cast<void*>(static_cast<const void*>(&opdata3)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs4, (TfLiteIntArray*)&outputs4, const_cast<void*>(static_cast<const void*>(&opdata4)), OP_SOFTMAX, },
};
static std::vector<void*> overflow_buffers;
static void * AllocatePersistentBuffer(struct TfLiteContext* ctx,
                                       size_t bytes) {
  void *ptr;
  if (current_location - bytes < tensor_boundary) {
    // OK, this will look super weird, but.... we have CMSIS-NN buffers which
    // we cannot calculate beforehand easily.
    ptr = ei_calloc(bytes, 1);
    if (ptr == NULL) {
      printf("ERR: Failed to allocate persistent buffer of size %d\n", (int)bytes);
      return NULL;
    }
    overflow_buffers.push_back(ptr);
    return ptr;
  }

  current_location -= bytes;

  ptr = current_location;
  memset(ptr, 0, bytes);

  return ptr;
}
typedef struct {
  size_t bytes;
  void *ptr;
} scratch_buffer_t;
static std::vector<scratch_buffer_t> scratch_buffers;

static TfLiteStatus RequestScratchBufferInArena(struct TfLiteContext* ctx, size_t bytes,
                                                int* buffer_idx) {
  scratch_buffer_t b;
  b.bytes = bytes;

  b.ptr = AllocatePersistentBuffer(ctx, b.bytes);
  if (!b.ptr) {
    return kTfLiteError;
  }

  scratch_buffers.push_back(b);

  *buffer_idx = scratch_buffers.size() - 1;

  return kTfLiteOk;
}

static void* GetScratchBuffer(struct TfLiteContext* ctx, int buffer_idx) {
  if (buffer_idx > static_cast<int>(scratch_buffers.size()) - 1) {
    return NULL;
  }
  return scratch_buffers[buffer_idx].ptr;
}

static TfLiteTensor* GetTensor(const struct TfLiteContext* context,
                               int tensor_idx) {
  return &tflTensors[tensor_idx];
}

static TfLiteEvalTensor* GetEvalTensor(const struct TfLiteContext* context,
                                       int tensor_idx) {
  return &tflEvalTensors[tensor_idx];
}

} // namespace

TfLiteStatus trained_model_init( void*(*alloc_fnc)(size_t,size_t) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  tensor_arena = (uint8_t*) alloc_fnc(16, kTensorArenaSize);
  if (!tensor_arena) {
    printf("ERR: failed to allocate tensor arena\n");
    return kTfLiteError;
  }
#else
  memset(tensor_arena, 0, kTensorArenaSize);
#endif
  tensor_boundary = tensor_arena;
  current_location = tensor_arena + kTensorArenaSize;
  ctx.AllocatePersistentBuffer = &AllocatePersistentBuffer;
  ctx.RequestScratchBufferInArena = &RequestScratchBufferInArena;
  ctx.GetScratchBuffer = &GetScratchBuffer;
  ctx.GetTensor = &GetTensor;
  ctx.GetEvalTensor = &GetEvalTensor;
  ctx.tensors = tflTensors;
  ctx.tensors_size = 14;
  for(size_t i = 0; i < 14; ++i) {
    tflTensors[i].type = kTfLiteFloat32;
    tflEvalTensors[i].type = kTfLiteFloat32;
    tflTensors[i].is_variable = 0;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    tflTensors[i].allocation_type = tensorData[i].allocation_type;
#else
    tflTensors[i].allocation_type = (tensor_arena <= tensorData[i].data && tensorData[i].data < tensor_arena + kTensorArenaSize) ? kTfLiteArenaRw : kTfLiteMmapRo;
#endif
    tflTensors[i].bytes = tensorData[i].bytes;
    tflTensors[i].dims = tensorData[i].dims;
    tflEvalTensors[i].dims = tensorData[i].dims;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    if(tflTensors[i].allocation_type == kTfLiteArenaRw){
      uint8_t* start = (uint8_t*) ((uintptr_t)tensorData[i].data + (uintptr_t) tensor_arena);

     tflTensors[i].data.data =  start;
     tflEvalTensors[i].data.data =  start;
    }
    else{
       tflTensors[i].data.data = tensorData[i].data;
       tflEvalTensors[i].data.data = tensorData[i].data;
    }
#else
    tflTensors[i].data.data = tensorData[i].data;
    tflEvalTensors[i].data.data = tensorData[i].data;
#endif // EI_CLASSIFIER_ALLOCATION_HEAP
    tflTensors[i].quantization.type = kTfLiteNoQuantization;
    if (tflTensors[i].allocation_type == kTfLiteArenaRw) {
      auto data_end_ptr = (uint8_t*)tflTensors[i].data.data + tensorData[i].bytes;
      if (data_end_ptr > tensor_boundary) {
        tensor_boundary = data_end_ptr;
      }
    }
  }
  if (tensor_boundary > current_location /* end of arena size */) {
    printf("ERR: tensor arena is too small, does not fit model - even without scratch buffers\n");
    return kTfLiteError;
  }
  registrations[OP_FULLY_CONNECTED] = Register_FULLY_CONNECTED();
  registrations[OP_SOFTMAX] = Register_SOFTMAX();

  for(size_t i = 0; i < 5; ++i) {
    tflNodes[i].inputs = nodeData[i].inputs;
    tflNodes[i].outputs = nodeData[i].outputs;
    tflNodes[i].builtin_data = nodeData[i].builtin_data;
    tflNodes[i].custom_initial_data = nullptr;
    tflNodes[i].custom_initial_data_size = 0;
    if (registrations[nodeData[i].used_op_index].init) {
      tflNodes[i].user_data = registrations[nodeData[i].used_op_index].init(&ctx, (const char*)tflNodes[i].builtin_data, 0);
    }
  }
  for(size_t i = 0; i < 5; ++i) {
    if (registrations[nodeData[i].used_op_index].prepare) {
      TfLiteStatus status = registrations[nodeData[i].used_op_index].prepare(&ctx, &tflNodes[i]);
      if (status != kTfLiteOk) {
        return status;
      }
    }
  }
  return kTfLiteOk;
}

static const int inTensorIndices[] = {
  0, 
};
TfLiteTensor* trained_model_input(int index) {
  return &ctx.tensors[inTensorIndices[index]];
}

static const int outTensorIndices[] = {
  13, 
};
TfLiteTensor* trained_model_output(int index) {
  return &ctx.tensors[outTensorIndices[index]];
}

TfLiteStatus trained_model_invoke() {
  for(size_t i = 0; i < 5; ++i) {
    TfLiteStatus status = registrations[nodeData[i].used_op_index].invoke(&ctx, &tflNodes[i]);

#if EI_CLASSIFIER_PRINT_STATE
    ei_printf("layer %lu\n", i);
    ei_printf("    inputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].inputs->size; ix++) {
      auto d = tensorData[tflNodes[i].inputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");

    ei_printf("    outputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].outputs->size; ix++) {
      auto d = tensorData[tflNodes[i].outputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");
#endif // EI_CLASSIFIER_PRINT_STATE

    if (status != kTfLiteOk) {
      return status;
    }
  }
  return kTfLiteOk;
}

TfLiteStatus trained_model_reset( void (*free_fnc)(void* ptr) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  free_fnc(tensor_arena);
#endif
  scratch_buffers.clear();
  for (size_t ix = 0; ix < overflow_buffers.size(); ix++) {
    free(overflow_buffers[ix]);
  }
  overflow_buffers.clear();
  return kTfLiteOk;
}
